"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.questionRouter = void 0;
const express_1 = require("express");
const question_record_1 = require("../records/question.record");
const errors_1 = require("../utils/errors");
exports.questionRouter = (0, express_1.Router)()
    .get('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const questions = yield question_record_1.QuestionRecord.getAll();
    res.json(questions);
}))
    .get('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const question = yield question_record_1.QuestionRecord.getOne(req.params.id);
    if (question === null) {
        res.json(question);
    }
    else {
        const answers = question.answers && typeof question.answers === 'string' ? JSON.parse(question.answers) : null;
        res.json(Object.assign(Object.assign({}, question), { answers }));
    }
}))
    .post('/', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const question = new question_record_1.QuestionRecord(req.body);
    yield question.insert();
    res.json(question);
}))
    .patch('/:id', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { body } = req;
    const question = yield question_record_1.QuestionRecord.getOne(req.params.id);
    if (question === null) {
        throw new errors_1.ValidationError('Could not find the question.');
    }
    if (body.answerBody.length < 1) {
        throw new errors_1.ValidationError('Error occured ! Form was submitted without data !');
    }
    yield question.update(body.answerBody);
    const updatedQuestion = yield question_record_1.QuestionRecord.getOne(req.params.id);
    const answers = updatedQuestion.answers && typeof updatedQuestion.answers === 'string' ? JSON.parse(updatedQuestion.answers) : null;
    res.json(Object.assign(Object.assign({}, updatedQuestion), { answers }));
}));
//# sourceMappingURL=question.router.js.map